module Test where

import Test.Tasty
import Test.Tasty.HUnit

import Refactor
import Fold
import Buchung

str1 = "Dies ist so ein Testsatz. Er enthält auch Wörter mit Umlauten "
  ++ "am Anfang des Wortes."

line1 = words str1

buch1 = [
  Auszahlung 20,
  Einzahlung 42,
  Auszahlung 23]

-- Tests

run = defaultMain $ testGroup "All tests" [refactorTests, foldTests,
  buchungTests]

refactorTests = testGroup "Tests für Aufgabe 1"
  [ testCase "stripVowels" $
    stripVowels str1 @=? stripVowels' str1
  , testCase "encrypt" $
    encrypt str1 @=? encrypt' str1
  , testCase "numWords" $
    numWords line1 @=? numWords' line1
  , testCase "len" $
    len line1 @=? len' line1
  , testCase "app" $
    app line1 "foo" @=? app' line1 "foo"
  , testCase "lineToString" $
    lineToString line1 @=? lineToString' line1
  ]

foldTests = testGroup "Tests für Aufgabe 2"
  [ testCase "map" $
    map (+2) [1, 5, 8] @=? map' (+2) [1, 5, 8]
  , testCase "filter" $
    filter (==5) [1, 5, 8] @=? filter' (==5) [1, 5, 8]
  ]

buchungTests = testGroup "Tests für Aufgabe 3"
  [ testCase "flatten" $
    flatten buch1 @=? [-20, 42, -23]
  , testCase "kontostand" $
    kontostand 100 buch1 @=? 99
  , testCase "abhebungen" $
    abhebungen buch1 @=? 43
  , testCase "einzahlungen" $
    einzahlungen buch1 @=? 42
  ]

